var tinder = require('tinder');

$(function() {
    userModule.initial()

    setTimeout(function(){
        if (userModule.userData().token && userModule.userData().token != "") {
            tinderModule.initial(tinder)
            tinderModule.tinderAuthentication()
        }
    },500)

    $( 'body' ).on('click', '#open-information-page', function(){
        chrome.tabs.create({url: $(this).attr('href')});
        return false;
    });

    $( document ).on('click', '#optionsPopup', function(){ 
        if (chrome.runtime.openOptionsPage) {
            chrome.runtime.openOptionsPage();
          } else {
            window.open(chrome.runtime.getURL('src/page_action/options.html'));
          }
    })

    $( document ).on( "click", ".btn-logout", function() {
        userModule.logout()
        $("#like-status").text("Logout successfully")
    })

    $( document ).on( "click", "#btn-get-assignment", function() {
        userModule.getAssignment().then(function(data) {
            console.log("Get assignment success")
            tinderModule.setLocation(function(err, result) {
                if (result && result.status == 200) {
                    console.log("Update location", result)
                } else {
                    alert ("CANNOT UPDATE LOCATION")
                }
            })
        })
    })

    $( document ).on( "click", "#runBotSwitch", function() {
        var isChecked = $(this).is(':checked')
        userModule.setBotState(isChecked).then(function() {
            console.log("Change state")
            $(".btn-get-assignment").attr("disabled", isChecked)
        })
        
        chrome.runtime.sendMessage({mode: "setRunBot", isRunBot: isChecked}, function(response) {
            console.log(isChecked)
        });
    })

    $( document ).on( "click", ".btn-pledge-vote", function() {
        userModule.increasePledgeToVote().then(function() {
            console.log("Increased")
        })
    })

    // Testing box
    $( document ).on( "click", "#get-id", function() {
        var userId = tinderModule.getUserId();
        $("#current-id").text(userId);
    })

    $(document).on("click", "#like-button", function(){
        var targetId = $("#id-input").val();

        tinderModule.like(targetId, function(err, result) {
            var likeStatus = err ? "Like fail!" : "Like successful!";
            $("#like-status").text(likeStatus);
        })
    })

    $(document).on("click", "#reply-button", function(){
        var targetId = $("#id-input").val();
        var message = $("#message-input").val();
        var userId = $("#current-id").text();
        var matchedId = targetId + userId;

        tinderModule.sendMessage(matchedId, message, function(err, result) {
            var replyStatus = err ? "Send message fail!" : "Send message successful!";
            $("#reply-status").text(replyStatus);
        })
    })

    $(document).on("click", "#rotate-button", function(){
        var targetId = $("#id-input").val();
        var userId = $("#current-id").text();
        var routeButton = $("#rotate-button")

        if (routeButton.val() !== "Rotate") {
            var matchedId = targetId + userId;
            $("#matched-id").val(matchedId);

            if (matchedId && matchedId !== '') {
                $("#rotate-button").val("Rotate");
            }
        } else {
            var matchedId = $("#matched-id").val ();
            matchedId = matchedId.slice(-(matchedId.length / 2)) + matchedId.slice(0, (matchedId.length / 2));
            $("#matched-id").val(matchedId);
        }
    })
    //

});
