var botModule = (function() {
	var rs = null;

	function startBot(data) {
		if (window.RiveScript === undefined || !data) {
			// Problem loading rivescript.js? Solve here.
		} else {
			// Create our RiveScript interpreter.
			rs = new RiveScript({
				utf8: true
			});

			// This won't work on the web!
			//rs.loadDirectory("brain");

			// Load our files from the brain/ folder.
			var rivescriptSource = data.assignment.script.rive || "";
			rs.loadFile(rivescriptSource).then(onReady).catch(onError);

			// You can register objects that can then be called
			// using <call></call> syntax
			rs.setSubroutine('fancyJSObject', function(rs, args){
				// doing complex stuff here
			});
		}
	}

	function onReady() {
		console.log("Bot is ready!")

		// Now to sort the replies!
		rs.sortReplies();
	}

	function onError(err, filename, lineno) {
		console.log('Error: ', err);
	}

	function reply(username, message) {
		if (rs) {
			return rs.reply(username, message);
		}
	}

	return {
		startBot: startBot,
		reply: reply
	}
})()
