// if you checked "fancy-settings" in extensionizr.com, uncomment this lines

// var settings = new Store("settings", {
//     "sample_setting": "This is how you use Store.js to remember values"
// });


//TODO: this uses a weird mix of callbacks and promises, refactor for consistency.
//TODO: Recursive timing functions are unnecessarily obtuse.

var isRunBot = false;
var tinder = require('../../js/node_modules/tinder');

var sessionStartAt = null;
var sessionEndAt = null;
var sessionSleepAt = null;
var myTinderId = '';
var sendLikeTimeouts = [];

chrome.extension.onMessage.addListener(
  function(request, sender, sendResponse) {
    if (request.mode == "setRunBot") {
      userModule.initialForBackground().then(function(data) {
        isRunBot = request.isRunBot;
        var userData = userModule.userData();

        // Start chat bot
        botModule.startBot(userData);

        if (userData.token && userData.token != "") {
          tinderModule.initial(tinder);
          tinderModule.tinderAuthentication().then(function(data) {
            myTinderId = tinderModule.getUserId();

            // Start auto "say hi" and "reply" mode
            recursiveFunction(replyMessage, TIME_CHECK_REPLY, true);
            recursiveFunction(sayHello, TIME_CHECK_NEW_CONVERSATION);
          })
        }

        if (!isRunBot) {
          for(var i=0; i < sendLikeTimeouts.length; i++) {
            clearTimeout(sendLikeTimeouts[i])
          }
        }

        sendResponse({isRunBot: request.isRunBot});
      })
    }

    try {
      chrome.pageAction.show(sender.tab.id);
    } catch (err) {

    }
    sendResponse();
});

var recursiveFunction = function(func, timeout, needSetSessionStatus) {
  if (isRunBot) {
    if (needSetSessionStatus) setSessionStatus();

    setTimeout(function() {
      if (isRunBot) {
        if (!sessionSleepAt) func();
        recursiveFunction(func, timeout, needSetSessionStatus);
      }
    }, timeout)
  }
}

var setSessionStatus = function() {
  var currentTime = new Date().getTime();

  if (sessionSleepAt && sessionSleepAt <= currentTime) {
    sessionSleepAt = null;
  }

  if (!sessionStartAt && !sessionEndAt && !sessionSleepAt) {
    sessionStart();
  }

  if (currentTime >= sessionEndAt && !sessionSleepAt) {
    sessionSleep();
  }
}

var sessionStart = function() {
  var newDate = new Date()
  var currentTime = newDate.getTime();

  sessionStartAt = currentTime;
  sessionEndAt = addMinutes(newDate, SESSION_WORK_TIME);

  //SEND START ASSIGNMENT LOG
  var meta = META.START_ASSIGNMENT;
  userModule.sendLogging({ tinderID: myTinderId,  meta, message: {} }).then(function(data) {
    console.log("Send to log start assignment")
  })

  setMatchedPoint();
  getAndLikeUser(10);
}

var sessionSleep = function() {
  sessionSleepAt = addMinutes(sessionEndAt, SESSION_SLEEP_TIME)
  sessionStartAt = null;
  sessionEndAt = null;

  setMatchedPoint()
  //SEND ASSIGNMENT SLEEPING LOG
  var meta = META.ASSIGNMENT_SLEEPING;
  userModule.sendLogging({ tinderID: myTinderId, meta, message: {} }).then(function(data) {
    console.log("Send to log assignment sleeping")
  })
}

var replyMessage = function() {
  tinderModule.getMatches('100', '1', function(err, result) {
    if (result) {
        var matches = result.data.matches || [];

        matches.forEach(function(user) {
            var messages = user.messages || [];
            var messageIndex = -1;
            var personId = user.person._id || '';

            if (messages[0] && messages[0].from !== myTinderId && myTinderId !== '') {
                tinderModule.getMessages(user.id, '100', function(err, result) {
                    if (result) {
                        messages = result.data.messages || [];

                        for (var i = 0; i < messages.length; i++) {
                            messageIndex = i;
                            if (messages[i].from == myTinderId) {
                                messageIndex = i - 1;
                                break;
                            } else {
                                sendLogMessage({
                                  tinderID: myTinderId,
                                  targetTinderID: personId,
                                  messageData: messages[i]
                                })
                            }
                        }

                        for (var i = messageIndex; i > -1 ; i--) {
                          if (!checkExpiredReply(messages[i].sent_date)) {
                            var messageToBot = messages[i].message
                            sendMessageToBot(messageToBot, user.id, personId)
                          }
                        }
                    }
                })
            }
        })
    }

    if (err) {
      checkForbiddenAuthenticateError(err);
    }
  })
}

var checkExpiredReply = function(time) {
  var currentTime = new Date().getTime();
  var messageSentAt = Date.parse(time);
  var waitingTime = currentTime - messageSentAt;
  if (waitingTime > EXPIRED_REPLY_TIME) {
    return true;
  } else {
    return false;
  }
}

var sayHello = function() {
  tinderModule.getMatches('100', '0', function(err, result) {
    if (result) {
      //Say Hello
      var matches = result.data.matches || [];
      matches.forEach(function(user) {
        var personId = user.person._id || '';
        sendMessageToBot('', user.id, personId, true);
      })
    }
  })
}

var sendMessageToBot = function(message, matchedId, targetTinderID, sayHello) {
  if (sayHello) {
    message = HELLO_MESSAGE;
  }

  botModule.reply(targetTinderID, message).then(function(reply) {
    if (reply == NO_REPLY || reply == "[NOREPLY]" || reply == "ERR: No Reply Matched") {
      return null;
    }
    if (reply.substring(0,4) == "ERR:") {
      return null;
    }

    // For test couting "Volting plans"
    if (message == '123321') {
      reply = 'Counting';
    }

    tinderModule.sendMessage(matchedId, reply, function(err, result) {
      if (err) {
        console.log(err);
      } else {
        sendLogMessage({
          tinderID: myTinderId,
          targetTinderID: targetTinderID,
          messageData: result
        })
      }
    });
  }).catch(function(e) {
      console.log('Reply error: ', e);
  });
};

var setMatchedPoint = function() {
  var count = -1;
  tinderModule.getMatches('100', '1', function(err, result) {
    if (result) {
      var matches = result.data.matches || [];
      count = matches.length;

      tinderModule.getMatches('100', '0', function(e, r) {
        if (r) {
          var mat = r.data.matches || [];
          count = count + mat.length;
        }
        userModule.setMatchedCount(count);
      })
    }
  });
}

var addMinutes = function(date, minutes) {
  return new Date(date.getTime() + minutes*60000);
}

var sendLogMessage = function({ tinderID, targetTinderID, messageData }) {
  var meta = tinderID == messageData.from ? META.MSSG_SENT : META.MSSG_RECEIVED;
  userModule.sendLogging({ tinderID, targetTinderID, meta, message: messageData }).then(function(data) {
    var userData = userModule.userData()
    chrome.runtime.sendMessage({
      msg: "updateVotingPlansMatchedCount",
      data: {
        userData
      }
    });
  })
}

var getAndLikeUser = function(limit) {
  tinderModule.getRecommendations(limit, function(err, result) {
    if (result) {
      var users = result.results || [];
      var count = 1;

      users.forEach(function(user){
        if (count < (limit * 8/10)) {
          var randomTime = (Math.round(Math.random() * 5000)) + (count * 15000);
          likeUserWithTimeout(user._id, randomTime);
        }
        count++;
      })
    }

    if (err) {
      checkForbiddenAuthenticateError(err);
    }
  })
}

var likeUserWithTimeout = function(id, time) {
  var timeout = setTimeout(function() {
    if (isRunBot) {
      tinderModule.like(id, function(err, result) {
        if (result) {
          var meta = META.PROFILE_LIKED;
          var currentTinderUserID = tinderModule.getUserId();
          userModule.sendLogging({ tinderID: currentTinderUserID, targetTinderID: id, meta, message: result }).then(function(data) {
            // console.log("Send to log PROFILE LIKED")
            // console.log('Like successfully!', result);
          }).catch(function(err) {
            console.log("Like fail! ERR: ", err);
          })
        }

        if (err) {
          checkForbiddenAuthenticateError(err);
        }
      })
    }
  }, time)
  sendLikeTimeouts.push(timeout)
}

var checkForbiddenAuthenticateError = function(err) {
  var errorStatus = err && err.status;
  if (errorStatus == 403) {
    alert("Forbidden! Your Tinder account has been suspended.");
    logout();
  }

  if (errorStatus == 401) {
    alert("Your logged session has expired, please login again.");
    logout();
  }
}

var logout = function(message) {
  isRunBot = false;
  userModule.logout();
  chrome.runtime.sendMessage({
    msg: "logout",
    message: message
  });
}
